import processing.serial.*;
Serial myPort;


int x=11; // start from x zero
int x2=750;  //start A from center
int y=461;  // start from y zero
int y2=750;  //start B from center

// some variables: nothing to  explain
int x1;
int x3;
int y1;
int y3;
int vel;
int acx;
int acy;
int mx;
int my;
int a1;
int a2;
int mvx;
int mvy;
String stringamx;
String stringamy;
String stringaax;
String stringaay;
PFont f;
PImage bg;



// start setting the drawable area
void setup()
{
 size(930, 650);                                      // 930px per 700px window
 f = createFont("Arial",16,true);                     // Create Font
 println(Serial.list());                              //print all the serial ports so you can set your own below
 myPort = new Serial(this, Serial.list()[2], 9600);   // setting the usb serial port to 9600 baudrate
 bg = loadImage("bg.jpg");                            // load my face
}

// let's populate the window
void draw()
{
  
  background(bg);          // put my face as background image

  
  //Motor X---------------------
  
  rectMode(CORNER);   
  stroke(#000000);          // draw a rectangle with border black
  fill(#60b246);            // and background green
  rect(10,310,300,30);      // that starts from point x=10px, y=310px, 300px width and 30pz height
  stroke(#cccccc);          // draw a rectangle with border grey
  fill(#ffffff);            // backgroung white
  rect(x,310,20,30);        // that starts from x variable and y=310px, 20px width and 30px height
  textFont(f,16);           // Specify font to be used
  fill(255);                  // Specify font color 
  text("X Motor Movement",100,300);  // Display fixed text in right position
  text(mvx,160,370);          // Display variable text in right position
  String xm = nf(x-11, 4);     
  stringamx = 'X' + xm;
  if(mouseX>10 && mouseX<290 && mouseY > 310 && mouseY< 340 && mousePressed)
  {                         // listen when user press the mouse button inside the main rectangle area
    x=mouseX;                 // x variable is where the mouse is (inside the area)
    mx=constrain(x,10,290);   // record the mouse position inside the max x mouvement inside the area
    mvx=abs(x-11);           // to obtain a real value, I substract the x starting point.
    xm = nf(mvx, 4);   // to obtain always 4 digit (is useful for parsing)
    stringamx = 'X' + xm;     // record the value in a string putting an X ahead.
    println(stringamx);       // print the value
    delay(500);            // wait 500ms
      
  }


// FROM THIS POINT I COMMENT ONLY NEW CODE

 //motor Y --------------------------

 rectMode(CORNER);
  stroke(#000000);          
  fill(#60b246);
 rect(450, 180, 30, 300);
 stroke(#cccccc);
  fill(#ffffff);
 rect(450, y, 30, 20);
  textFont(f,16);           
  fill(255);                  
  text("Y Motor Movement",393,150);  
  text(mvy,455,500);  
  String ym = nf(abs(y-461), 4);
  stringamy = 'Y' + ym;       
 if (mouseX>450 && mouseX<480 && mouseY > 180 && mouseY< 460 && mousePressed)
 {
   y=mouseY;
   my=constrain(y, 180, 461);
   mvy=abs(y-461);  // i want an high value up and low value down
   ym = nf(mvy, 4);
   stringamy = 'Y' + ym;
   println(stringamy);
   delay(500);            // wait 500ms
     
 }
 
  
 
 //X motor acceleration ---------------------
  
  rectMode(CORNER);
  stroke(#000000);
  fill(#60b246);
  rect(610,250,300,30);
  stroke(#cccccc);
  fill(#ffffff);
  rect(x2,250,20,30);
  textFont(f,16);           
  fill(255);                  
  text("X Motor Acceleration",690,240);  
  a2 = x2-610;
  text(a2,580,270);          
  String ax = nf(abs(x2-610), 4);
  stringaax = 'A' + ax; 
  if(mouseX>610 && mouseX<891 && mouseY > 250 && mouseY< 280 && mousePressed)
  {
    x2=mouseX;
    acx=constrain(x2,610,891);
    a2=abs(acx-610);
    ax = nf(a2, 4);
    stringaax = 'B' + ax;
    println(stringaax);
    delay(500);            // wait 500ms
  }
  
  
  
  
  
 //Y motor acceleration--------------------------

  rectMode(CORNER);
  stroke(#000000);
  fill(#60b246);
  rect(610,310,300,30);
  stroke(#cccccc);
  fill(#ffffff);
  rect(y2,310,20,30);
  textFont(f,16);           
  fill(255);                  
  text("Y Motor Acceleration",690,305);    
  a1 = y2-610;
  text(a1,580,330);   
  String ay = nf(abs(y2-610), 4);
  stringaay = 'B' + ay;   
 if (mouseX>610 && mouseX<891 && mouseY > 310 && mouseY< 340 && mousePressed)
 {
   y2=mouseX;
   acy=constrain(y2, 610, 891);
   a1=abs(acy-610);
   ay = nf(a1, 4);
   stringaay =  'B' + ay;
   println(stringaay);
   delay(500);            // wait 500ms
  
 }
 
 
 
 
  //BUTTON---------------

  rectMode(CORNER);
  stroke(#60b246);
  fill(#000000);
  rect(820,370,90,30);
  textFont(f,16);           
  fill(255);                  
  text("START",840,392);  
  if(mouseX>820 && mouseX<910 && mouseY > 370 && mouseY< 400 && mousePressed)
  {
  String gcode='#' + stringaax + stringaay + stringamx + stringamy ;  // join all the sctring and put at the begin
  myPort.write(gcode);  // write on serial port
  println(gcode);        // print on screen
  delay(500);            // wait 500ms
  }
}


